<?php

namespace App\Http\Controllers;
use App\Models\contact1;
use App\Models\contact2;
use App\Models\contact3;
use App\Models\chat;
use App\Models\User;
use App\Models\Agent;
use App\Models\AdminLogin;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;

class AgentController extends Controller
{
    public function AgentLogin(){
        return view('agent.login');
    }

    public function AgentLogedIn(Request $request){
        // dd("hello");
        $credentials = $request->only(['email', 'password']);
        // dd($credentials);

        if (Auth::guard('AgentLogin')->attempt($credentials, $request->filled('remember'))) {
            // return $user = Auth::guard('AdminLogin')->user();
            // dd("success");
            return redirect()->route('agent.dashboard')->with('success', 'Welcome to Admin Dashboard');        
        }else{
            // dd("failed");
            return back()->withErrors(['email' => 'Invalid credentials'])->withInput($request->only('email'));        
        }
    }

    public function logout()
    {
        Auth::guard('AgentLogin')->logout();
        return redirect()->route('agent.login');
    }

    public function dashboard(){
        // dd("hello");
        // $check = Auth::check();
        // dd($check);
        if(Auth::check()){
            $user = Auth::guard('AgentLogin')->user();
            $filered_product = [];
            $products = [];
            $agent_product_list=[];
            $orders1 = [];

            $agent_assigned = DB::connection('mysql')
                ->table('agent_assinged')
                ->where('agent_id', $user->id)
                ->get();
            // dd($agent_assigned);    
            $agentassign = DB::connection('mysql')
                ->table('agent_assinged')
                ->where('agent_id', $user->id)
                ->first();
                dd($agentassign);
                
            $assined = DB::connection('mysql')
                ->table('agent_assinged')
                ->get();
                if($agentassign!=''){
                    $product_maped = DB::connection('mysql')->table('assigned_agent_product_map')->where('agent_assinged_id',$agentassign->id)->get();
                }else{
                    $product_maped = [];
                }

                dd($product_maped);           

            // $orders = DB::connection('mysql')->table('orders')->where('id',$agentassign->OID)->get();
            // foreach($agent_assigned as $agent_assigneds){
            //     $orders[] = DB::connection('mysql')->table('orders')->where('id',$agent_assigneds->OID)->first();
                
            // }
            foreach($agent_assigned as $agent_assigneds){
	            $orders1[] = DB::connection('mysql')->table('orders')
	            			->leftJoin('agent_assinged', 'agent_assinged.OID', '=', 'orders.id')
	                        ->where('orders.id',$agent_assigneds->OID)
	                        ->where('agent_assinged.agent_id',$user->id)
	                        ->select('orders.id','agent_assinged.agent_id','orders.unique_order_id')
	                        ->first();
	        }
            // dd($orders);

            // return $orders;
            // foreach($product_maped as $product_mapeds){
            //     $products[] = DB::connection('mysql')->table('products')->where('id',$product_mapeds->product_id)->first();
            //     $agent_product_list[] = DB::connection('mysql')->table('agent_product_list')->where('id',$product_mapeds->product_id)->first();

            // }

            foreach($product_maped as $product_mapeds){
                $agent_product_list[] = DB::connection('mysql')->table('agent_product_list')
                                        ->where('id',$product_mapeds->product_id)
                                        ->first();
            }
            // dd($agent_product_list);

            // $agents = DB::connection('mysql')->table('agents')->get();
            $order_details = DB::connection('mysql')->table('order_details')->get();
            $orders = DB::connection('mysql')->table('orders')->get();
            $assigned_agent_product_map =  DB::connection('mysql')->table('assigned_agent_product_map')->get();

            return view('agent.dashboard', compact('user','agent_assigned','assigned_agent_product_map','products','order_details','orders','product_maped','agent_product_list','assined','orders1'));
        }else{
            return redirect()->route('agent.login');
        }
    }

    public function dashSearch(Request $request,$agentid){
        $user = Auth::guard('AgentLogin')->user();
        $filered_product = [];
        $products = [];

        $agent_assigned = DB::connection('mysql')
            ->table('agent_assinged')
            ->where('agent_id', $user->id)
            ->whereBetween('created_at', [$request['fromDate'], $request['toDate']])
            ->where('status', $request['status'])
            ->get();
        $agentassign = DB::connection('mysql')
            ->table('agent_assinged')
            ->where('agent_id', $user->id)
            ->first();
            
        $product_maped= DB::connection('mysql')->table('assigned_agent_product_map')->where('agent_assinged_id',$agentassign->id)->get();
        $orders = DB::connection('mysql')->table('orders')->where('id',$agentassign->OID)->first();
        $order_details = DB::connection('mysql')->table('order_details')->where('order_id',$orders->id)->get();
        foreach($order_details as $order_detail){
            foreach($product_maped as $product_mapeds){
                if($order_detail->product_id == $product_mapeds->product_id){
                    $products[] = DB::connection('mysql')->table('products')->where('id',$product_mapeds->product_id)->first();

                }
            }
        }

        $assigned_agent_product_map =  DB::connection('mysql')->table('assigned_agent_product_map')->get();

        $assined = DB::connection('mysql')
            ->table('agent_assinged')
            ->get();

        return view('agent.dashboard', compact('user','agent_assigned','assigned_agent_product_map','products','order_details','orders','assined'));
    
    }

    public function generateReport(){
        $user = Auth::guard('AgentLogin')->user();
        return view('agent.generateReport',compact('user'));
    }

    public function GetReport(Request $request){
        $deliveryPrice = 0;
        $TotalAmount = 0;
        $profit = 0;
        $user = Auth::guard('AgentLogin')->user();
        $start_date = $request['start-date'];
        $end_date = $request['end-date'];
        $agent = DB::connection('mysql')->table('agents')->where('id',$user->id)->first();

        $agent_assinged = DB::connection('mysql')
        ->table('agent_assinged')
        ->where('status','D')
        ->where('agent_id',$user->id)
        ->whereBetween('created_at', [$start_date, $end_date])
        ->get();  
        foreach($agent_assinged as $agent_assingeds){
            $assigned_agent_product_map =  DB::connection('mysql')->table('assigned_agent_product_map')->where('agent_assinged_id',$agent_assingeds->id)->get();
            $order = DB::connection('mysql')->table('orders')->where('id',$agent_assingeds->OID)->first();
            $orderPlaced = DB::connection('mysql')->table('orders')->where('id',$agent_assingeds->OID)->get();
            $orderDetails= DB::connection('mysql')->table('order_details')->where('order_id',$agent_assingeds->OID)->get();

            if($agent_assingeds->OID == $order->id){
                $deliveryPrice += $agent_assingeds->totalPrice;
            }
            foreach($orderDetails as $orderDetail){
                $TotalAmount += $orderDetail->total_price;
            }
            $profit =( $TotalAmount / $deliveryPrice) * 100;

            // if($order->id == $agent_assingeds->OID){
            //     foreach($agent as $agents){
            //         if($agent_assingeds->agent_id == $agents->id){
            //             $getAgentName[] = $agents->name;

            //         }
            //     }
            // }
        }

        foreach($orderPlaced as $orders){
                $profitReportData[] = [
                    'unique_order_id' => $orders->unique_order_id,
                    'delivery_date' => $orderDetails[0]->delivery_date ?? null,
                    'delivery_city_name' => $orderDetails[0]->delivery_city_name ?? null,
                    'totalOrderPrice' => $TotalAmount,
                    'placementTotal' => $deliveryPrice,
                    'profit' => $profit,
                    'agent_name' => $agent->name,
                    'status' => 'DELIVERED',
                ];
        }
        // return $assigned_agent_product_map;
        // return $request->all();
        // return view('GetPriceByProduct',compact('user','start_date','end_date'));
        return view('agent.GetReport',compact('agent_assinged','assigned_agent_product_map','orderDetails','order','agent','profitReportData','start_date','end_date'));

    }

    public function orderDetails($id,$agentId){
        $user = Auth::guard('AgentLogin')->user();
        $agent_assinged = DB::connection('mysql')->table('agent_assinged')->where('agent_order_id',$id)->where('agent_id',$agentId)->first();
        $agents = DB::connection('mysql')->table('agents')->where('id',$agentId)->first();
        $product = [];
        $agent_product_list=[];
        $product_maped = DB::connection('mysql')->table('assigned_agent_product_map')->where('agent_assinged_id',$agent_assinged->id)->get();
        $orders = DB::connection('mysql')->table('orders')->where('id',$agent_assinged->OID)->first();
        $order_details = DB::connection('mysql')->table('order_details')->where('order_id',$orders->id)->get();
            foreach($product_maped as $product_mapeds){
                if($agent_assinged->id == $product_mapeds->agent_assinged_id){
                    // $products[] = DB::connection('mysql')->table('products')->where('id',$product_mapeds->product_id)->first();
                     $agent_product_list[] =  DB::connection('mysql')->table('agent_product_list')->where('id',$product_mapeds->product_id)->first();

                }
            }
        // return $agent_product_list;
        return view('agent.OrderDetails',compact('agent_assinged','product_maped','orders','order_details','user','agent_product_list','agents','agentId'));
    }

    public function UpdateProductStatus($orderId,$agentID,Request $request){
        $extra = $request['extra'];
        $deliVery = $request['deliveryCharge'];
        $reason = $request['reason'];
        $status = $request['status'];
        $track_no = $request['track_no'];
        
        $rules = ['status' => 'required'];

        if ($status == 'S') {
            $rules['track_no'] = 'required';
        } elseif (in_array($status, ['H', 'CL'])) {
            $rules['reason'] = 'required';
        }

        $messages = [
            'status.required' => 'Please enter the required field for status.',
            'track_no.required' => 'Please provide the tracking number.',
            'reason.required' => 'Please provide a reason.',
        ];

        $validator = Validator::make($request->all(), $rules, $messages);

        if ($validator->fails()) {
            return redirect()->back()->withErrors($validator)->withInput();
        }

        DB::connection('mysql')->table('agent_assinged')->where('agent_order_id',$orderId)->where('agent_id',$agentID)->update([    
                'extra'=> $extra,
                'Deliver_charge' => $deliVery,
                'reason' => $reason,
                'track_no'=>$track_no,
                'status' => $status,
            ]);

      
        return back();
    }

    public function updateStatus(Request $request){
        $order_id = $request['order_id'];
        $update_status =$request['update_status'];
        DB::connection('mysql')->table('orderproduct')->where('id',$order_id)->update ([
            "status"=> $request['update_status'],
        ]);
        DB::connection('mysql')->table('assinged')->where('order_id',$order_id)->update ([
            "remark"=>$request['Remark_add'],
        ]);
        DB::connection('mysql')->table('delivery_action')->where('order_id',$order_id)->update ([
            "status"=> $request['update_status'],
        ]);
    
        return 'done';
    }

}
