<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use App\Models\CmsPages;
use Illuminate\Support\Facades\Auth;

class CmsController extends Controller
{
	public function list(Request $request)
	{

        $result=CmsPages::get();
        // dd($result);
        return view('admin.cms.list', ['result' => $result, 'request' => $request]);
	}

	public function add(Request $request){

        $obj = new CmsPages;

        if($request->isMethod('POST')){
           
            $request->validate([
                'title'=>'required',
                'content'=>'required',
                'meta_title'=>'required',
                'meta_description'=>'required'
            ]);

            if($cms = $obj->create([
                    'title' => $request->title, 
                    'content' => $request->content, 
                    'slug' => $request->slug,
                    'meta_title' => $request->meta_title, 
                    'meta_description' => $request->meta_description,
                    'created_by' => Auth::guard('AdminLogin')->user()->id
                ]))
            {
                $request->session()->flash('alert-success', 'CMS successfully added.');
                return redirect()->route('admin.cms.list');
            }else{
                $request->session()->flash('alert-danger', 'Sorry! There was an unexpected error. Try again!');
                return redirect()->back()->with($request->except(['_method', '_token']));
            }
            
        }

        return view('admin.cms.add', ['request' => $request]);
    }

    public function edit($id = null, Request $request){

        $id = base64_decode($id);
		$dataDetails  = CmsPages::where('id',$id)->first();

        $obj = new CmsPages;

        if($request->isMethod('POST')){
            
            $request->validate([
                'title'=>'required',
                'content'=>'required',
                'meta_title'=>'required',
                'meta_description'=>'required'
            ]);
            
            $update_arr['title'] = $request->title;
            $update_arr['content'] = $request->content;
            $update_arr['slug'] = $request->slug;
            $update_arr['meta_title'] = $request->meta_title;
            $update_arr['meta_description'] = $request->meta_description;

            if(CmsPages::where(['id' => $request->formid])->update($update_arr)){
                   
                $request->session()->flash('alert-success', 'CMS successfully updated.');
                return redirect()->route('admin.cms.list');
            }else{
                $request->session()->flash('alert-danger', 'Sorry! There was an unexpected error. Try again!');
                return redirect()->back()->with($request->except(['_method', '_token']));
            }
        }

        return view('admin.cms.edit', ['dataDetails' => $dataDetails, 'request' => $request]);
    }

    public function list_cms($id = null, Request $request){

        // if($id == null){
        //     return redirect()->route('admin.category.list');
        // }
        $id = base64_decode($id);
        // dd($id);
        if ($id>0){
            $list_cms = DB:: table('sites')
                            ->join('site_wise_cms','sites.id','=','site_wise_cms.site_id')
                            ->where(['site_wise_cms.cms_id'=>$id])
                            ->get();
            // dd($list_banners);
        }
        return view('admin.cms.list_cms', ['cms_id' => $id, 'list_cms' => $list_cms, 'request' => $request]);
    }

}