<?php $__env->startSection('content'); ?>

<main id="main" class="main">
    <?php if(Session::get('permissions.user_type') == 'A'): ?>
        <div class="d-flex justify-content-end mb-3">
            <a href="<?php echo e(route('admin.product')); ?>" class="btn btn-outline-info">Back</a>
        </div>
        <form action="<?php echo e(route('admin.status-update')); ?>" method="post" class="status-form">
            <?php echo csrf_field(); ?>

            <?php
                $statuses = [
                    'AOF' => $aof,
                    'BOF' => $bof,
                    'COF' => $cof,
                    'DOF' => $dof,
                    'HOF' => $hof,
                    'KOF' => $kof,
                    'MOF' => $mof,
                    'POF' => $pof,
                ];
            ?>

            <?php $__currentLoopData = $statuses; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $label => $status): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                <fieldset class="row mb-4">
                    <legend class="col-form-label col-sm-2 pt-0 fw-bold"><?php echo e($label); ?> Product Status</legend>
                    <div class="col-sm-10">
                        <div class="form-check form-check-inline">
                            <input class="form-check-input" type="radio" name="<?php echo e(strtolower($label)); ?>" id="<?php echo e(strtolower($label)); ?>1" value="Y" <?php echo e($status == 'Y' ? 'checked' : ''); ?>>
                            <label class="form-check-label" for="<?php echo e(strtolower($label)); ?>1">Yes</label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input class="form-check-input" type="radio" name="<?php echo e(strtolower($label)); ?>" id="<?php echo e(strtolower($label)); ?>0" value="N" <?php echo e($status == 'N' ? 'checked' : ''); ?>>
                            <label class="form-check-label" for="<?php echo e(strtolower($label)); ?>0">No</label>
                        </div>
                    </div>
                </fieldset>
            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>

            <div class="text-center">
                <button type="submit" class="btn btn-lg btn-info">Submit</button>
                <input type="hidden" name="id" value="<?php echo e($id); ?>" />
            </div>
        </form>
    <?php endif; ?>
</main>

<style>
    .status-form {
        max-width: 800px;
        margin: 0 auto;
        padding: 20px;
        background: #f9f9f9;
        border: 1px solid #ddd;
        border-radius: 10px;
        box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
    }

    .status-form fieldset {
        padding: 10px;
        border: 1px solid #e3e3e3;
        border-radius: 5px;
        background: #fff;
    }

    .status-form legend {
        font-size: 1.1rem;
        color: #333;
    }

    .form-check-input {
        margin-right: 5px;
    }

    .btn-info {
        background-color: #17a2b8;
        border-color: #17a2b8;
    }

    .btn-info:hover {
        background-color: #138496;
        border-color: #117a8b;
    }

    .text-center {
        margin-top: 20px;
    }
</style>

<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-YvpcrYf0tY3lHB60NNkmXc5s9fDVZLESaAA55NDzOxhy9GkcIdslK1eN7N6jIeHz" crossorigin="anonymous"></script>

<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.admin.app', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/adminrighflorist/public_html/resources/views/admin/product/status.blade.php ENDPATH**/ ?>